#!/usr/bin/env python
# -*- coding: UTF-8 -*-
'''
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
'''
from selenium import webdriver
from selenium.webdriver.common.by import By

from log_util import logger


# https://xueqiu.com/

class TestXueQiu:
    def setup_class(self):
        # 初始化 driver
        self.driver = webdriver.Chrome()
        # 最大化浏览器
        self.driver.maximize_window()
        # 隐式等待 0.5 轮询查找，避免后边直接查找  找不到报错
        self.driver.implicitly_wait(15)

        # 进入雪球
        self.driver.get("https://xueqiu.com/")

        logger.info("进入雪球")
        self.driver.save_screenshot("进入雪球.png")

    def teardown_class(self):
        self.driver.quit()

    def test_search(self):
        '''
        1.输入搜索关键词
        2.点击搜索按钮
        3.点击讨论
        4.选择第一篇文章（可以跳转新页面）
        :return:
        '''
        # 定位搜索输入框 输入内容
        self.driver.find_element(By.CSS_SELECTOR, '[placeholder="搜索"]').send_keys("阿里巴巴")
        # 点击搜索按钮
        self.driver.find_element(By.CSS_SELECTOR, ".iconfont_iconfont_9UW.index_iconfont_mYK ").click()
        logger.info("输入关键字进行搜索")
        # 点击 讨论
        self.driver.find_element(By.XPATH, "//*[@class='search__tabs__border']/a[2]").click()

        # 点击第一篇文章
        self.driver.find_element(By.CLASS_NAME, "timeline__item__title").click()
        logger.info("点击第一篇文章")
        # 切换窗口
        handles = self.driver.window_handles  # 所有句柄
        old_handles = self.driver.current_window_handle  # 获取当前句柄
        self.driver.switch_to.window(handles[-1])  # 切换到新的句柄
        new_handles = self.driver.current_window_handle
        print(f"所有的句柄{handles}")
        print(f"切换前的句柄{old_handles}")
        print(f"切换后的句柄{new_handles}")
        # 获取弹框1所在的源码信息
        page_source1 = self.driver.page_source
        with open("page_source1.html", 'w') as f:
            f.write(page_source1)
        # 判断
        if "跳过" in page_source1:
            self.driver.save_screenshot("弹框1.png")
            self.driver.find_element(By.XPATH, "//*[text()='跳过']").click()
        # 获取新的 弹框2 所在的源码信息
        page_source2 = self.driver.page_source
        with open('page_source2.html', 'w') as f:
            f.write(page_source2)
        # 判断 并且关闭弹框2
        if "close close_jianlian" in page_source2:
            self.driver.save_screenshot("弹框2.png")
            self.driver.find_element(By.CSS_SELECTOR, ".close.close_jianlian").click()

        # 获取正文文本内容 -> web控件的列表
        eles = self.driver.find_elements(By.CSS_SELECTOR, ".article__bd__detail p")
        text_list = []  # 存放所有p标签文本的列表
        for i in eles:
            text_list.append(i.text)
        print(text_list)
        # "阿里巴巴" in i    for i in text_list
        assert any(["阿里巴巴" in i for i in text_list])
        logger.info("搜索成功")
        self.driver.save_screenshot("搜索成功.png")

        # assert "阿里巴巴" in text_list[x]
        # 判断 ”阿里巴巴“ 在正文中 -> 在每个 p 标签的文本值去判断 -> [p1.text,p2.text.......]-> ['阿里巴巴xxxx','wwwwww',....]
